unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Spin, ExtCtrls, PolarChart, ImgList, ComCtrls, PolarFill,
  Menus, Math, TabNotBk, Buttons, ExtDlgs;

type
  TForm1 = class(TForm)
    ImageList1: TImageList;
    Timer1: TTimer;
    PopupMenu1: TPopupMenu;
    Exit1: TMenuItem;
    PC: TSLXPolarChart;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    GroupBox1: TGroupBox;
    Label5: TLabel;
    VertAxisColor: TColorBox;
    VertAxisWidth: TSpinEdit;
    VertAxisStyle: TComboBoxEx;
    GroupBox2: TGroupBox;
    Label4: TLabel;
    HorzAxisColor: TColorBox;
    HorzAxisWidth: TSpinEdit;
    HorzAxisStyle: TComboBoxEx;
    GroupBox3: TGroupBox;
    Label3: TLabel;
    ExtCircleColor: TColorBox;
    ExtCircleWidth: TSpinEdit;
    ExtCircleStyle: TComboBoxEx;
    GroupBox4: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    IntCircleColor: TColorBox;
    IntCircleWidth: TSpinEdit;
    IntCircleRadius: TSpinEdit;
    IntCircleStyle: TComboBoxEx;
    GroupBox7: TGroupBox;
    Label12: TLabel;
    CircleGridColor: TColorBox;
    CircleGridWidth: TSpinEdit;
    CircleGridStyle: TComboBoxEx;
    GroupBox8: TGroupBox;
    Label13: TLabel;
    RadialGridColor: TColorBox;
    RadialGridWidth: TSpinEdit;
    RadialGridStyle: TComboBoxEx;
    GroupBox6: TGroupBox;
    Label6: TLabel;
    Series1Color: TColorBox;
    Series1Width: TSpinEdit;
    Series1Style: TComboBoxEx;
    TabSheet3: TTabSheet;
    Label7: TLabel;
    FillStyle: TComboBox;
    GroupBox5: TGroupBox;
    GroupBox10: TGroupBox;
    Label8: TLabel;
    BackGroundColor: TColorBox;
    Label9: TLabel;
    Label10: TLabel;
    GradientColor1: TColorBox;
    GradientColor2: TColorBox;
    Label11: TLabel;
    GradientSteps: TSpinEdit;
    GroupBox12: TGroupBox;
    PictureEdit: TEdit;
    SelectBGpictureBtn: TSpeedButton;
    SelectPictureDialog: TOpenDialog;
    GroupBox9: TGroupBox;
    Label14: TLabel;
    Series2Color: TColorBox;
    Series2Width: TSpinEdit;
    Series2Style: TComboBoxEx;
    Label15: TLabel;
    GradientDirection: TComboBox;
    procedure VertAxisWidthChange(Sender: TObject);
    procedure HorzAxisWidthChange(Sender: TObject);
    procedure VertAxisColorChange(Sender: TObject);
    procedure HorzAxisColorChange(Sender: TObject);
    procedure ExtCircleColorChange(Sender: TObject);
    procedure ExtCircleWidthChange(Sender: TObject);
    procedure IntCircleRadiusChange(Sender: TObject);
    procedure IntCircleColorChange(Sender: TObject);
    procedure IntCircleWidthChange(Sender: TObject);
    procedure BackGroundColorChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure VertAxisStyleChange(Sender: TObject);
    procedure HorzAxisStyleChange(Sender: TObject);
    procedure ExtCircleStyleChange(Sender: TObject);
    procedure IntCircleStyleChange(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Series1ColorChange(Sender: TObject);
    procedure Series1StyleChange(Sender: TObject);
    procedure Series1WidthChange(Sender: TObject);
    procedure FillStyleChange(Sender: TObject);
    procedure GradientColor1Change(Sender: TObject);
    procedure GradientColor2Change(Sender: TObject);
    procedure GradientStepsChange(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure PCPaint(Sender: TObject);
    procedure CircleGridStyleChange(Sender: TObject);
    procedure RadialGridStyleChange(Sender: TObject);
    procedure CircleGridColorChange(Sender: TObject);
    procedure RadialGridColorChange(Sender: TObject);
    procedure CircleGridWidthChange(Sender: TObject);
    procedure RadialGridWidthChange(Sender: TObject);
    procedure SelectBGpictureBtnClick(Sender: TObject);
    procedure Series2ColorChange(Sender: TObject);
    procedure Series2StyleChange(Sender: TObject);
    procedure Series2WidthChange(Sender: TObject);
    procedure GradientDirectionChange(Sender: TObject);
    procedure PictureEditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure PictureEditEnter(Sender: TObject);
    procedure PictureEditExit(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.VertAxisWidthChange(Sender: TObject);
begin
  PC.VertAxis.Width:=VertAxisWidth.Value;
end;

procedure TForm1.HorzAxisWidthChange(Sender: TObject);
begin
  PC.HorzAxis.Width:=HorzAxisWidth.Value;
end;

procedure TForm1.ExtCircleWidthChange(Sender: TObject);
begin
  PC.ExtCircle.Width:=ExtCircleWidth.Value;
end;

procedure TForm1.IntCircleWidthChange(Sender: TObject);
begin
  PC.IntCircle.Width:=IntCircleWidth.Value;
end;

procedure TForm1.VertAxisColorChange(Sender: TObject);
begin
  PC.VertAxis.Color:=VertAxisColor.Selected;
end;

procedure TForm1.HorzAxisColorChange(Sender: TObject);
begin
  PC.HorzAxis.Color:=HorzAxisColor.Selected;
end;

procedure TForm1.ExtCircleColorChange(Sender: TObject);
begin
  PC.ExtCircle.Color:=ExtCircleColor.Selected;
end;

procedure TForm1.IntCircleColorChange(Sender: TObject);
begin
  PC.IntCircle.Color:=IntCircleColor.Selected;
end;

procedure TForm1.IntCircleRadiusChange(Sender: TObject);
begin
  PC.IntCircle.Raduis:=IntCircleRadius.Value;
end;

procedure TForm1.BackGroundColorChange(Sender: TObject);
begin
  PC.BackGround.Color:=BackGroundColor.Selected;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  VertAxisStyle.ItemIndex:=6;
  HorzAxisStyle.ItemIndex:=6;
  ExtCircleStyle.ItemIndex:=6;
  IntCircleStyle.ItemIndex:=6;
  Series1Style.ItemIndex:=6;
  Series2Style.ItemIndex:=6;
  PC.AddSeries;
  CircleGridStyle.ItemIndex:=4;
  RadialGridStyle.ItemIndex:=4;
  CircleGridColor.Selected:=clTeal;
  RadialGridColor.Selected:=clNavy;
  Form1.Constraints.MinHeight:=Height;
  Form1.Constraints.MinWidth:=Width;
  Form1.Left:=(Screen.WorkAreaWidth-Form1.Width) div 2;
  Form1.Top:=(Screen.WorkAreaHeight-Form1.Height) div 2;
  Timer1.Enabled:=True;
  PC.AddSeries;
  PC.AddSeries;
  PC.Series[0].Color:=clRed;
  PC.Series[1].Color:=clNavy;
end;

procedure TForm1.VertAxisStyleChange(Sender: TObject);
begin
  case VertAxisStyle.ItemIndex of
   0: begin
        PC.VertAxis.Style:=psClear;
      end;
   1: begin
        PC.VertAxis.Style:=psDash;
      end;
   2: begin
        PC.VertAxis.Style:=psDashDot;
      end;
   3: begin
        PC.VertAxis.Style:=psDashDotDot;
      end;
   4: begin
        PC.VertAxis.Style:=psDot;
      end;
   5: begin
        PC.VertAxis.Style:=psInsideFrame;
      end;
   6: begin
        PC.VertAxis.Style:=psSolid;
      end;
  end;
end;

procedure TForm1.HorzAxisStyleChange(Sender: TObject);
begin
  case HorzAxisStyle.ItemIndex of
   0: begin
        PC.HorzAxis.Style:=psClear;
      end;
   1: begin
        PC.HorzAxis.Style:=psDash;
      end;
   2: begin
        PC.HorzAxis.Style:=psDashDot;
      end;
   3: begin
        PC.HorzAxis.Style:=psDashDotDot;
      end;
   4: begin
        PC.HorzAxis.Style:=psDot;
      end;
   5: begin
        PC.HorzAxis.Style:=psInsideFrame;
      end;
   6: begin
        PC.HorzAxis.Style:=psSolid;
      end;
  end;
end;

procedure TForm1.ExtCircleStyleChange(Sender: TObject);
begin
  case ExtCircleStyle.ItemIndex of
   0: begin
        PC.ExtCircle.Style:=psClear;
      end;
   1: begin
        PC.ExtCircle.Style:=psDash;
      end;
   2: begin
        PC.ExtCircle.Style:=psDashDot;
      end;
   3: begin
        PC.ExtCircle.Style:=psDashDotDot;
      end;
   4: begin
        PC.ExtCircle.Style:=psDot;
      end;
   5: begin
        PC.ExtCircle.Style:=psInsideFrame;
      end;
   6: begin
        PC.ExtCircle.Style:=psSolid;
      end;
  end;
end;

procedure TForm1.IntCircleStyleChange(Sender: TObject);
begin
  case IntCircleStyle.ItemIndex of
   0: begin
        PC.IntCircle.Style:=psClear;
      end;
   1: begin
        PC.IntCircle.Style:=psDash;
      end;
   2: begin
        PC.IntCircle.Style:=psDashDot;
      end;
   3: begin
        PC.IntCircle.Style:=psDashDotDot;
      end;
   4: begin
        PC.IntCircle.Style:=psDot;
      end;
   5: begin
        PC.IntCircle.Style:=psInsideFrame;
      end;
   6: begin
        PC.IntCircle.Style:=psSolid;
      end;
  end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  PC.Series[0].AddPoint(Timer1.Tag*2*PI/(100)+PI,Timer1.Tag);
  PC.Series[1].AddPoint(-Timer1.Tag*2*PI/(100)-PI,Timer1.Tag);
  Timer1.Tag:=Timer1.Tag+1;
end;

procedure TForm1.Series1ColorChange(Sender: TObject);
begin
  PC.Series[0].Color:=Series1Color.Selected;
end;

procedure TForm1.Series1StyleChange(Sender: TObject);
var tstyle: TPenStyle;
begin
  tstyle:=psSolid;
  case Series1Style.ItemIndex of
   0: begin
        tstyle:=psClear;
      end;
   1: begin
        tstyle:=psDash;
      end;
   2: begin
        tstyle:=psDashDot;
      end;
   3: begin
        tstyle:=psDashDotDot;
      end;
   4: begin
        tstyle:=psDot;
      end;
   5: begin
        tstyle:=psInsideFrame;
      end;
   6: begin
        tstyle:=psSolid;
      end;
  end;
  PC.Series[0].Style:=tstyle;
end;

procedure TForm1.Series1WidthChange(Sender: TObject);
begin
  PC.Series[0].Width:=Series1Width.Value;
end;

procedure TForm1.FillStyleChange(Sender: TObject);
begin
  case FillStyle.ItemIndex of
    0: begin
      PC.BackGround.Style:=gsSolid;
    end;
    1: begin
      PC.BackGround.Style:=gsGradient;
    end;
    2: begin
      PC.BackGround.Style:=gsPicture;
    end;
  end;
end;

procedure TForm1.GradientColor1Change(Sender: TObject);
begin
  PC.BackGround.GradientStart:=GradientColor1.Selected;
end;

procedure TForm1.GradientColor2Change(Sender: TObject);
begin
  PC.BackGround.GradientEnd:=GradientColor2.Selected;
end;

procedure TForm1.GradientStepsChange(Sender: TObject);
begin
  PC.BackGround.GradientSteps:=GradientSteps.Value;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.PCPaint(Sender: TObject);
begin
  SetBkMode(PC.Canvas.Handle, TRANSPARENT);
  PC.Canvas.TextOut(0,PC.Height-15,'OnPaint test - point '+IntToStr(Timer1.Tag));
  SetBkMode(PC.Handle, OPAQUE);
end;

procedure TForm1.CircleGridStyleChange(Sender: TObject);
var tstyle: TPenStyle;
begin
  tstyle:=psSolid;
  case CircleGridStyle.ItemIndex of
   0: begin
        tstyle:=psClear;
      end;
   1: begin
        tstyle:=psDash;
      end;
   2: begin
        tstyle:=psDashDot;
      end;
   3: begin
        tstyle:=psDashDotDot;
      end;
   4: begin
        tstyle:=psDot;
      end;
   5: begin
        tstyle:=psInsideFrame;
      end;
   6: begin
        tstyle:=psSolid;
      end;
  end;
  PC.GridCircle.Style:=tstyle;
end;

procedure TForm1.RadialGridStyleChange(Sender: TObject);
var tstyle: TPenStyle;
begin
  tstyle:=psSolid;
  case RadialGridStyle.ItemIndex of
   0: begin
        tstyle:=psClear;
      end;
   1: begin
        tstyle:=psDash;
      end;
   2: begin
        tstyle:=psDashDot;
      end;
   3: begin
        tstyle:=psDashDotDot;
      end;
   4: begin
        tstyle:=psDot;
      end;
   5: begin
        tstyle:=psInsideFrame;
      end;
   6: begin
        tstyle:=psSolid;
      end;
  end;
  PC.GridRadial.Style:=tstyle;
end;

procedure TForm1.CircleGridColorChange(Sender: TObject);
begin
  PC.GridCircle.Color:=CircleGridColor.Selected;
end;

procedure TForm1.RadialGridColorChange(Sender: TObject);
begin
  PC.GridRadial.Color:=RadialGridColor.Selected;
end;

procedure TForm1.CircleGridWidthChange(Sender: TObject);
begin
  PC.GridCircle.Width:=CircleGridWidth.Value;
end;

procedure TForm1.RadialGridWidthChange(Sender: TObject);
begin
  PC.GridRadial.Width:=RadialGridWidth.Value;
end;

procedure TForm1.SelectBGpictureBtnClick(Sender: TObject);
begin
  if SelectPictureDialog.Execute then begin
    PC.BackGround.Picture.LoadFromFile(SelectPictureDialog.FileName);
    PictureEdit.Text:=SelectPictureDialog.FileName;
  end;
end;

procedure TForm1.Series2ColorChange(Sender: TObject);
begin
  PC.Series[1].Color:=Series2Color.Selected;
end;

procedure TForm1.Series2StyleChange(Sender: TObject);
var tstyle: TPenStyle;
begin
  tstyle:=psSolid;
  case Series2Style.ItemIndex of
   0: begin
        tstyle:=psClear;
      end;
   1: begin
        tstyle:=psDash;
      end;
   2: begin
        tstyle:=psDashDot;
      end;
   3: begin
        tstyle:=psDashDotDot;
      end;
   4: begin
        tstyle:=psDot;
      end;
   5: begin
        tstyle:=psInsideFrame;
      end;
   6: begin
        tstyle:=psSolid;
      end;
  end;
  PC.Series[1].Style:=tstyle;
end;

procedure TForm1.Series2WidthChange(Sender: TObject);
begin
  PC.Series[1].Width:=Series2Width.Value;
end;

procedure TForm1.GradientDirectionChange(Sender: TObject);
begin
  case GradientDirection.ItemIndex of
    0: begin
         PC.BackGround.GradientDirection:=gdVertical;
       end;
    1: begin
         PC.BackGround.GradientDirection:=gdHorizontal;
       end;
  end;
end;

procedure TForm1.PictureEditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key=VK_RETURN then begin
    PC.BackGround.Picture.LoadFromFile(PictureEdit.Text);
  end;
end;

procedure TForm1.PictureEditEnter(Sender: TObject);
begin
  if PictureEdit.Text='Select Picture' then begin
    PictureEdit.Text:='';
  end;
end;

procedure TForm1.PictureEditExit(Sender: TObject);
begin
  if PictureEdit.Text='' then begin
    PictureEdit.Text:='Select Picture';
  end;
end;

end.
