(*********************************************************)
(* Extended Graphics Functions for TSLXPolarChart        *)
(* distributed for free, non-commercial purpose          *)
(*  2007 by Sl-Alex http://www.sl-alex.nm.ru/           *)
(*********************************************************)
unit GraphicsExt;

interface

uses Graphics;

//     ( )
// +    psSolid-   1 
// +  psSolid-      
procedure DrawEllipseExt(Canvas: TCanvas;Pen: TPen;X1,Y1,X2,Y2: Integer);

//    
// +    psSolid-   1 
// +  psSolid-      
procedure DrawLineExt(Canvas: TCanvas;Pen: TPen;X1,Y1,X2,Y2: Integer);

//    
procedure CopyFontProps(Source: TFont; Dest: TFont);

//    
procedure CopyPenProps(Source: TPen; Dest: TPen);

implementation

//     ( )
// +    psSolid-   1 
// +  psSolid-      
procedure DrawEllipseExt(Canvas: TCanvas;Pen: TPen;X1,Y1,X2,Y2: Integer);
var i: Integer;
    anglestepline: Double;
    anglestepspace: Double;
    anglestepdot: Double;
    X1int,Y1int: Integer;
    X2int,Y2int: Integer;
    curStyle: TPenStyle;
    Width, Height: Integer;
var count: Integer;
begin
  curStyle:=Pen.Style;
  Width  := X2-X1;
  Height := Y2-Y1;
  CopyPenProps(Pen,Canvas.Pen);
  Canvas.Pen.Style:=psSolid;
  //  psDash - 
  if curStyle=psDash then begin
    Count:=(Width+Height) div 16;
    anglestepline:=(3/4)*(2*PI/count);
    anglestepspace:=(1/4)*(2*PI/count);
    for i:=0 to COUNT-1 do begin
      X1int:=X1+(Width div 2)+Round(cos((anglestepline+anglestepspace)*i)*(Width));
      Y1int:=Y1+(Height div 2)+Round(sin((anglestepline+anglestepspace)*i)*(Height));
      X2int:=X1+(Width div 2)+Round(cos((anglestepline+anglestepspace)*i+anglestepline)*(Width));
      Y2int:=Y1+(Height div 2)+Round(sin((anglestepline+anglestepspace)*i+anglestepline)*(Height));
      Canvas.Arc(X1,Y1,X2,Y2,X2int,Y2int,X1int,Y1int);
    end;
  end;
  //  psClear -  
  if curStyle=psClear then begin
    {   }
  end;
  //  psDot - 
  if curStyle=psDot then begin
    Count:=(Width+Height) div (2*Canvas.Pen.Width);
    anglestepdot:=(2*PI/count);
    for i:=0 to COUNT-1 do begin
      X1int:=X1+(Width div 2)+Round(cos((anglestepdot)*i)*(Width div 2));
      Y1int:=Y1+(Height div 2)+Round(sin((anglestepdot)*i)*(Height div 2));
      Canvas.Brush.Color:=Canvas.Pen.Color;
      if Canvas.Pen.Width>1 then begin
        Canvas.Ellipse(X1int-(Canvas.Pen.Width div 2),Y1int-(Canvas.Pen.Width div 2),X1int+(Canvas.Pen.Width div 2),Y1int+(Canvas.Pen.Width div 2));
      end else begin
        Canvas.Pixels[X1int,Y1int]:=Canvas.Pen.Color;
      end;
    end;
  end;
  //  psSolid -  
  if curStyle=psSolid then begin
    Canvas.Arc(X1,Y1,X2,Y2,0,0,0,0);
  end;
  //  psInsideFrame -       
  if curStyle=psInsideFrame then begin
    Canvas.Arc(X1+(Canvas.Pen.Width div 2),Y1+(Canvas.Pen.Width div 2),X2-(Canvas.Pen.Width div 2),Y2-(Canvas.Pen.Width div 2),0,0,0,0);
  end;
  //  psDashDot - -
  if curStyle=psDashDot then begin
    Count:=(Width+Height) div 16;
    anglestepline:=(2/4)*(2*PI/count);
    anglestepdot:=(1/4)*(2*PI/count);
    anglestepspace:=(1/4)*(2*PI/count);
    for i:=0 to COUNT-1 do begin
      //  
      X1int:=X1+(Width div 2)+Round(cos((anglestepline+anglestepdot+anglestepspace)*i)*(Width));
      Y1int:=Y1+(Height div 2)+Round(sin((anglestepline+anglestepdot+anglestepspace)*i)*(Height));
      X2int:=X1+(Width div 2)+Round(cos((anglestepline+anglestepdot+anglestepspace)*i+anglestepline)*(Width));
      Y2int:=Y1+(Height div 2)+Round(sin((anglestepline+anglestepdot+anglestepspace)*i+anglestepline)*(Height));
      Canvas.Arc(X1,Y1,X2,Y2,X2int,Y2int,X1int,Y1int);
      //  
      X1int:=X1+(Width div 2)+Round(cos((anglestepline+anglestepdot+anglestepspace)*i+anglestepline+anglestepdot)*(Width div 2));
      Y1int:=Y1+(Height div 2)+Round(sin((anglestepline+anglestepdot+anglestepspace)*i+anglestepline+anglestepdot)*(Height div 2));
      Canvas.Brush.Color:=Canvas.Pen.Color;
      if Canvas.Pen.Width>1 then begin
        Canvas.Ellipse(X1int-(Canvas.Pen.Width div 2),Y1int-(Canvas.Pen.Width div 2),X1int+(Canvas.Pen.Width div 2),Y1int+(Canvas.Pen.Width div 2));
      end else begin
        Canvas.Pixels[X1int,Y1int]:=Canvas.Pen.Color;
      end;
    end;
  end;
  //  psDashDotDot - --
  if curStyle=psDashDotDot then begin
    Count:=(Width+Height) div 16;
    anglestepline:=(3/9)*(2*PI/count);
    anglestepdot:=(4/9)*(2*PI/count);
    anglestepspace:=(2/9)*(2*PI/count);
    for i:=0 to COUNT-1 do begin
      //  
      X1int:=X1+(Width div 2)+Round(cos((anglestepline+anglestepdot+anglestepspace)*i)*(Width));
      Y1int:=Y1+(Height div 2)+Round(sin((anglestepline+anglestepdot+anglestepspace)*i)*(Height));
      X2int:=X1+(Width div 2)+Round(cos((anglestepline+anglestepdot+anglestepspace)*i+anglestepline)*(Width));
      Y2int:=Y1+(Height div 2)+Round(sin((anglestepline+anglestepdot+anglestepspace)*i+anglestepline)*(Height));
      Canvas.Arc(X1,Y1,X2,Y2,X2int,Y2int,X1int,Y1int);
      //  
      X1int:=X1+(Width div 2)+Round(cos((anglestepline+anglestepdot+anglestepspace)*i+anglestepline+(anglestepdot/2))*(Width div 2));
      Y1int:=Y1+(Height div 2)+Round(sin((anglestepline+anglestepdot+anglestepspace)*i+anglestepline+(anglestepdot/2))*(Height div 2));
      Canvas.Brush.Color:=Canvas.Pen.Color;
      if Canvas.Pen.Width>1 then begin
        Canvas.Ellipse(X1int-(Canvas.Pen.Width div 2),Y1int-(Canvas.Pen.Width div 2),X1int+(Canvas.Pen.Width div 2),Y1int+(Canvas.Pen.Width div 2));
      end else begin
        Canvas.Pixels[X1int,Y1int]:=Canvas.Pen.Color;
      end;
      //   
      X1int:=X1+(Width div 2)+Round(cos((anglestepline+anglestepdot+anglestepspace)*i+anglestepline+anglestepdot)*(Width div 2));
      Y1int:=Y1+(Height div 2)+Round(sin((anglestepline+anglestepdot+anglestepspace)*i+anglestepline+anglestepdot)*(Height div 2));
      Canvas.Brush.Color:=Canvas.Pen.Color;
      if Canvas.Pen.Width>1 then begin
        Canvas.Ellipse(X1int-(Canvas.Pen.Width div 2),Y1int-(Canvas.Pen.Width div 2),X1int+(Canvas.Pen.Width div 2),Y1int+(Canvas.Pen.Width div 2));
      end else begin
        Canvas.Pixels[X1int,Y1int]:=Canvas.Pen.Color;
      end;
    end;
  end;
end;

//    
// +    psSolid-   1 
// +  psSolid-      
procedure DrawLineExt(Canvas: TCanvas;Pen: TPen;X1,Y1,X2,Y2: Integer);
var Width, Height: Integer;
    count: Integer;
    curStyle: TPenStyle;
    stepX,stepY, lengthX, lengthY, dotX, dotY: Double;
    i: Integer;
begin
  curStyle:=Pen.Style;
  Width:=X2-X1;
  Height:=Y2-Y1;
  CopyPenProps(Pen, Canvas.Pen);
  Canvas.Pen.Style:=psSolid;
  //  psDash - 
  if curStyle=psDash then begin
    count:=Round(Sqrt(Sqr(Width)+Sqr(Height))) div 32;
    if count=0 then exit;
    lengthX:=(3/4)*Width/count;
    lengthY:=(3/4)*Height/count;
    stepX:=(Width-LengthX)/count;
    stepY:=(Height-LengthY)/count;
    for i:=0 to count do begin
      Canvas.MoveTo(X1+Round(stepX*i),Y1+Round(stepY*i));
      Canvas.LineTo(X1+Round(stepX*i)+Round(lengthX),Y1+Round(stepY*i)+Round(lengthY));
    end;
  end;
  //  psClear -  
  if curStyle=psClear then begin
    {   }
  end;
  //  psDot - 
  if curStyle=psDot then begin
    count:=Round(Sqrt(Sqr(Width)+Sqr(Height))) div (4*Canvas.Pen.Width);
    if count=0 then exit;
    lengthX:=(2/4)*Width/count;
    lengthY:=(2/4)*Height/count;
    stepX:=(Width-LengthX)/count;
    stepY:=(Height-LengthY)/count;
    for i:=0 to count do begin
      if Canvas.Pen.Width>1 then begin
        Canvas.Ellipse(X1+Round(stepX*i)-(Canvas.Pen.Width div 2),Y1+Round(stepY*i)-(Canvas.Pen.Width div 2),
                       X1+Round(stepX*i)+(Canvas.Pen.Width div 2),Y1+Round(stepY*i)+(Canvas.Pen.Width div 2));
      end else begin
        Canvas.Pixels[X1+Round(stepX*i),Y1+Round(stepY*i)]:=Canvas.Pen.Color;
      end;
    end;
  end;
  //  psSolid -  
  if curStyle=psSolid then begin
    Canvas.MoveTo(X1,Y1);
    Canvas.LineTo(X2,Y2);
  end;
  //  psInsideFrame -       
  if curStyle=psInsideFrame then begin
    Canvas.MoveTo(X1,Y1);
    Canvas.LineTo(X2,Y2);
  end;
  //  psDashDot - -
  if curStyle=psDashDot then begin
    count:=Round(Sqrt(Sqr(Width)+Sqr(Height))) div 32;
    if count=0 then exit;
    lengthX:=(2/4)*Width/count;
    lengthY:=(2/4)*Height/count;
    dotX:=(1/4)*Width/count;
    dotY:=(1/4)*Height/count;
    stepX:=(Width-LengthX)/count;
    stepY:=(Height-LengthY)/count;
    for i:=0 to count do begin
      //  
      Canvas.MoveTo(X1+Round(stepX*i),Y1+Round(stepY*i));
      Canvas.LineTo(X1+Round(stepX*i)+Round(lengthX),Y1+Round(stepY*i)+Round(lengthY));
      //  
      if Canvas.Pen.Width>1 then begin
        Canvas.Ellipse(X1+Round(stepX*i+lengthX+dotX)-(Canvas.Pen.Width div 2),Y1+Round(stepY*i+lengthY+dotY)-(Canvas.Pen.Width div 2),
                       X1+Round(stepX*i+lengthX+dotX)+(Canvas.Pen.Width div 2),Y1+Round(stepY*i+lengthY+dotY)+(Canvas.Pen.Width div 2));
      end else begin
        Canvas.Pixels[X1+Round(stepX*i+lengthX+dotX),Y1+Round(stepY*i+lengthY+dotY)]:=Canvas.Pen.Color;
      end;
    end;
  end;
  //  psDashDotDot - --
  if curStyle=psDashDotDot then begin
    count:=Round(Sqrt(Sqr(Width)+Sqr(Height))) div 32;
    if count=0 then exit;
    lengthX:=(3/9)*Width/count;
    lengthY:=(3/9)*Height/count;
    dotX:=(3/18)*Width/count;
    dotY:=(3/18)*Height/count;
    stepX:=(Width-LengthX)/count;
    stepY:=(Height-LengthY)/count;
    for i:=0 to count do begin
      //  
      Canvas.MoveTo(X1+Round(stepX*i),Y1+Round(stepY*i));
      Canvas.LineTo(X1+Round(stepX*i)+Round(lengthX),Y1+Round(stepY*i)+Round(lengthY));
      //  
      if Canvas.Pen.Width>1 then begin
        Canvas.Ellipse(X1+Round(stepX*i+lengthX+dotX)-(Canvas.Pen.Width div 2),Y1+Round(stepY*i+lengthY+dotY)-(Canvas.Pen.Width div 2),
                       X1+Round(stepX*i+lengthX+dotX)+(Canvas.Pen.Width div 2),Y1+Round(stepY*i+lengthY+dotY)+(Canvas.Pen.Width div 2));
      end else begin
        Canvas.Pixels[X1+Round(stepX*i+lengthX+dotX),Y1+Round(stepY*i+lengthY+dotY)]:=Canvas.Pen.Color;
      end;
      //   
      if Canvas.Pen.Width>1 then begin
        Canvas.Ellipse(X1+Round(stepX*i+lengthX+2*dotX)-(Canvas.Pen.Width div 2),Y1+Round(stepY*i+lengthY+2*dotY)-(Canvas.Pen.Width div 2),
                       X1+Round(stepX*i+lengthX+2*dotX)+(Canvas.Pen.Width div 2),Y1+Round(stepY*i+lengthY+2*dotY)+(Canvas.Pen.Width div 2));
      end else begin
        Canvas.Pixels[X1+Round(stepX*i+lengthX+2*dotX),Y1+Round(stepY*i+lengthY+2*dotY)]:=Canvas.Pen.Color;
      end;
    end;
  end;
end;

//    
procedure CopyFontProps(Source: TFont; Dest: TFont);
begin
  Dest.Charset:=Source.Charset;
  Dest.Color:=Source.Color;
  Dest.Height:=Source.Height;
  Dest.Name:=Source.Name;
  Dest.Pitch:=Source.Pitch;
  Dest.Size:=Source.Size;
  Dest.Style:=Source.Style;
end;

//    
procedure CopyPenProps(Source: TPen; Dest: TPen);
begin
  Dest.Color:=Source.Color;
  Dest.Mode:=Source.Mode;
  Dest.Style:=Source.Style;
  Dest.Width:=Source.Width;
end;

end.
