(*********************************************************)
(* Extended Mathematic Functions for TSLXPolarChart      *)
(* distributed for free, non-commercial purpose          *)
(*  2007 by Sl-Alex http://www.sl-alex.nm.ru/           *)
(*********************************************************)
unit MathExt;

interface

uses Math;

//    X*10^Y  X  Y,  X   0..1
procedure FrExp10(Value: Extended; var Mantissa: Extended; var Exponent: Integer);
//        Adigit=-1 -   0.1, ADigit=1 -   10
function FloorTo(Value: Extended; ADigit:Integer): Extended;
//        Adigit=-1 -   0.1, Adigit=1 -   10
function CeilTo(Value: Extended; ADigit:Integer): Extended;


implementation

//    X*10^Y  X  Y,  X   0..1
procedure FrExp10(Value: Extended; var Mantissa: Extended; var Exponent: Integer);
var tempsign: ShortInt;
begin
  tempsign:=Sign(Value);
  Value:=abs(Value);
  if Value=0 then begin
    Mantissa:=0;
    Exponent:=0;
    Exit;
  end;
  Exponent:=Sign(Log10(Value))*Floor(abs(Log10(Value)));
  Mantissa:=Value/IntPower(10,Exponent);
  if Mantissa>1 then begin
    if Sign(Exponent)=0 then
      Exponent:=Exponent+1
    else
      Exponent:=Exponent+Sign(Exponent);
    Mantissa:=Mantissa/10;
  end;
  Mantissa:=Mantissa*tempsign;
end;

//        Adigit=-1 -   0.1, ADigit=1 -   10
function FloorTo(Value: Extended; ADigit:Integer): Extended;
begin
  Value:=Sign(Value)*Floor(abs(Value)*(Power(10,-ADigit)))/Power(10,-ADigit);
  FloorTo:=Value;
end;

//        Adigit=-1 -   0.1, Adigit=1 -   10
function CeilTo(Value: Extended; ADigit:Integer): Extended;
begin
  Value:=Sign(Value)*Ceil(abs(Value)*(Power(10,-ADigit)))/Power(10,-ADigit);
  CeilTo:=Value;
end;

end.
